//+------------------------------------------------------------------+
//|                                             pipchannel indicator |
//|                                                            Mikko |
//|                                                                  |
//+------------------------------------------------------------------+
//mod:levels   ki
#property copyright "Mikko"
#property link      "http://www.currencylabs.com"

//#property indicator_separate_window
#property indicator_chart_window
#property indicator_buffers 4

#property indicator_color1 Silver
#property indicator_color2 Silver

#property indicator_color3 SlateGray
#property indicator_color4 SlateGray

#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1
#property indicator_style3 2
#property indicator_style4 2

double high[];
double low[];

double highLv[];
double lowLv[];

extern int pipsMove = 50;
extern int channelWidth = 100;

extern bool ShowLevels = true;

extern int LevelHigh= 50;
extern int LevelLow =-50;


int init() {

   IndicatorBuffers(4);
   
   SetIndexBuffer(0, high);   
   SetIndexStyle(0, DRAW_LINE); 
   
   SetIndexBuffer(1, low);     
   SetIndexStyle(1, DRAW_LINE);
   
   int draw; if (ShowLevels) draw = DRAW_LINE; else draw = DRAW_NONE;
   SetIndexBuffer(2, highLv);   
   SetIndexStyle (2, draw); 
   
   SetIndexBuffer(3, lowLv);     
   SetIndexStyle (3, draw);

   SetIndexLabel(0, "Channel "+channelWidth+" High");     
   SetIndexLabel(1, "Channel "+channelWidth+" Low");     

   SetIndexLabel(2, "Channel "+channelWidth+" level High "+LevelHigh+"");     
   SetIndexLabel(3, "Channel "+channelWidth+" level Low "+LevelLow+"");     


   IndicatorShortName("Mikko pipschannel "+pipsMove+","+channelWidth+" ");

   return(0);
}
  
int deinit() {
   return(0);
}
     
int start() {
       
   int counted_bars=IndicatorCounted();
  
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
       
   int limit = Bars - counted_bars;      
   
   for(int i = limit-1; i >= 0; i--) {      
         
      high[i] = high[i+1];
      low[i] = low[i+1];

      
      
      while(High[i+1] > high[i]+pipsMove*Point) {
         high[i] = high[i]+pipsMove*Point;
         low[i] = high[i]-channelWidth*Point;
      } 
      
      while(Low[i+1] < low[i]-pipsMove*Point) {
         low[i] = low[i]-pipsMove*Point;
         high[i] = low[i]+channelWidth*Point;
      }


      highLv[i] = high[i]+LevelHigh*Point;
      lowLv [i] = low[i] +LevelLow *Point;

   } 
   return(0);
}

